

.MEMORYMAP
  SLOTSIZE $4000
  DEFAULTSLOT 1
  SLOT 0 $0000
  SLOT 1 $4000
.ENDME

.ROMBANKSIZE $4000
.ROMBANKS 2

.EMPTYFILL $00
.CARTRIDGETYPE 1
.COMPUTECHECKSUM
.COMPUTECOMPLEMENTCHECK

.include "hw.inc"
.include "rst.inc"
.include "logo.inc"

.bank 0 slot 0

; ==========
; interrupts
; ==========

; vblank
.org $0040
;jp _vblank
reti

; LCDC status
.org $0048
reti

; timer overflow
.org $0050
;jp _timer
reti

; serial transfer completion
.org $0058
 reti

; gamepad
.org $0060
reti

; ==========

; cartridge header: $0100 to $014f
.org $101
jp _start

.org $150
_start:

 ;di
 ; configure interrupts
 ld a,%00000101
 ld (IE),a

 ; stack in HRAM
 ld sp, $fff0

 ; init work area in RAM to $00
 ; [debug]
 ; ...

 call _lcd_di

 ; LCD control configuration
 ld hl,LCDC
 ld a,(hl)
 and %10000000
 or %01010001
 ld (LCDC),a

 ; reset LCD position and scrolling
 ld a,$00
 ld (SCY),a
 ld (SCX),a
 ld (WY),a
 ld (WX),a

 ; sound
 ld (NR52),a ; no sound 

 ; joypad
 ld (P1),a

 ; palettes
 ld a,%11100100
 ld (BGP),a

 ld a,$00
 ld (OBP1),a
 ld a,$00
 ld (OBP0),a

 ; set bg map in VRAM (9800h-9BFFh)
 ld b,$10
 ld c,$10
 ld de,$0010
 ld hl,$9800+$22 ; (y_offset*$20)+x_offset
 ld a,$00
_bg_set:
 ldi (hl),a
 inc a
 dec b
 jp nz,_bg_set
 add hl,de
 ld b,$10
 dec c
 jp nz,_bg_set

 ; load tile data in VRAM (8000h-8FFFh)
 ld b,$80
 ld c,$20
 ld hl,_bg_tile_data
 ld de,$8000
_tl_ld:
 ldi a,(hl)
 ld (de),a
 inc de
 dec b
 jp nz,_tl_ld
 ld b,$80
 dec c
 jp nz,_tl_ld

 call _lcd_en

_l0:
 jp _l0

_lcd_en:
  ld hl,LCDC
  ld a,(hl)
  or %10000000 ; (run / bit7=1)
  ld (hl),a
  ; ei
  ret

_lcd_di:
  di
  ; vblank period starts after line 144 is drawn (LY >= 144)
  ld a,(LY)
  cp 145
  jr nz,_lcd_di
  ld hl,LCDC
  ld a,(hl)
  and %01111111 ; (stopped / bit7=0)
  ld (hl),a
  ; ei
  ret

.include "mario_128x128.inc"

